from core import app
from flask import flash, url_for, session, redirect,request,render_template
from datetime import datetime, date, time, timedelta
from functools import wraps
from core.library.auth import Auth
from core.model.Society import Society

# Flask View decorators
class RouteGroup:

	def login_required(f):
		@wraps(f)
		def wrap(*args, **kwargs):
			# if user is not logged in, redirect to login page      
			if Auth.check(request.view_args['society_id']):
				return f(*args, **kwargs)
			else:
				flash("Your session has expired. Please try again.","errorMsg")
				return redirect(url_for('member.homeloginsociety',society_id=request.view_args['society_id'],society_key=request.view_args['society_key']))
		return wrap


	def society_required(f):
		@wraps(f)
		def wrap(*args, **kwargs):
			# if user is not logged in, redirect to login page      
			society_id = request.view_args['society_id']
			society_key = request.view_args['society_key']
			society = Auth.getSociety(society_id)
			if society and Auth.checkSocietybyIdKey(request.view_args['society_id'],request.view_args['society_key']):
				return f(*args, **kwargs)
			else:
				society = Society().getSociety(society_id,society_key)
				# print(society)
				if society:
					Auth.setSociety(society)
					return f(*args, **kwargs)
				else:
					flash("Invalid URL","errorMsg")
					return render_template('memberapp_users/display_msg.html')
		return wrap
	
		
	
	def bo_login_required(f):
		@wraps(f)
		def wrap(*args, **kwargs):
			
			# if user is not logged in, redirect to login page      
			if Auth.check(request.view_args['society_id']):
				return f(*args, **kwargs)
			else:
				if Auth.check(request.view_args['society_id']):
					flash("Access denied","errorMsg")
				else:
					flash("Your session has expired. Please try again...","errorMsg")
				return redirect(url_for('backoffice.Backoffice',society_id=request.view_args['society_id'],society_key=request.view_args['society_key']))
		return wrap
